;; -*- emacs-lisp -*-
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; $Id: gnus_dumbquotes.el,v 1.4 2006-11-06 21:02:42 rscholz Exp $
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Dumbquotes als Unicode-Zeichen
;;
;; Die offizielle Quelle dieser Datei ist
;;   <http://www.zonix.de/projects/emacs/config>
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; Dumbquotes mit Unicode-Zeichen, wg. utf-8-Kodierung in externer Datei

;; für XEmacs (T. Hungenberg in <2002112018558765usxh08.fsf.usenet@demonium.de>)
;;;###coding system: utf-8

;; Repariert mit `W d' im Summary Buffer falsch deklarierte Zeichen

;; Torsten Hilbrich in <87666gligg.fsf@myrkr.in-berlin.de>
(setq gnus-article-dumbquotes-map
  '(("\200" "€")
    ("\202" "‚")
    ("\203" "ƒ")
    ("\204" "„")
    ("\205" "…")
    ("\206" "†")
    ("\207" "‡")
    ("\210" "ˆ")
    ("\211" "‰")
    ("\212" "Š")
    ("\213" "‹")
    ("\214" "Œ")
    ("\216" "Ž")
    ("\221" "‘")
    ("\222" "’")
    ("\223" "“")
    ("\224" "”")
    ("\225" "•")
    ("\226" "–")
    ("\227" "—")
    ("\230" "˜")
    ("\231" "™")
    ("\232" "š")
    ("\233" "›")
    ("\234" "œ")
    ("\236" "ž")
    ("\237" "Ÿ")))

;; Local Variables:
;; coding: utf-8
;; End:
