;; -*- emacs-lisp -*-
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; $Id: gnus_epop3.el,v 1.5 2006-11-06 21:02:42 rscholz Exp $
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Einstellungen fr ePOP3 - Mailboxen abfragen
;;
;; Die offizielle Quelle dieser Datei ist
;;   <http://www.zonix.de/projects/emacs/config>
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; EPOP3                    (inkompatibel zu Emacs 21, Quelle unbekannt)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(add-to-list 'load-path (concat zonix-elisp-dir "epop3"))
(add-to-list 'load-path (concat zonix-elisp-dir "elib"))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Initialisierung
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(require 'epop3mail)
(autoload 'epop3-mail "epop3mail"
  "Get mail from pop server for PO:USER@HOST and put it in TOFILE." t)

;(autoload 'start-biff "epop3mail" "pop3 biff, unleashed" t)
;(autoload 'stop-biff "epop3mail" "pop3 biff, muzzled" t)
;(autoload 'restart-biff "epop3mail" "pop3 biff, RE-unleashed" t)
(autoload 'flush-pop-passwords "epop3mail" "flush passwords" t)
(autoload 'stuff-pop-passwords "epop3mail" "pre-load passwords" t)
(autoload 'epop3-load-passwords-from-alist' "epop3mail" "load passwds" t)
;(autoload 'biffs-current-language "epop3mail" "what is biff talking?" t)
;(autoload 'biffs-last-check "epop3mail" "when did biff last check?" t)
;(autoload 'speak-biff! "biff-mode" "make biff speak" t)

;; nur das Feature zum Managen (Lschen auf dem Server) der Boxen nutzen
(autoload 'epop3-manage-mailbox "epop3manage" "manage POP3 mailbox" t)


;; Mails auch wirklich lschen
(setq epop3-manage-really-delete t)


;; Benutzung
(define-key global-map [(shift f4)] 'epop3-manage-mailbox) 
