;; -*- emacs-lisp -*-
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; $Id: gnus_randomsig.el,v 1.8 2006-11-06 21:02:42 rscholz Exp $
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;  Automatische Signaturen
;;
;; Die offizielle Quelle dieser Datei ist
;;   <http://www.zonix.de/projects/emacs/config>
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; randomsig.el     <http://www.backmes.de/scripts+programs/randomsig.el>
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(require 'randomsig)
(define-key message-mode-map "\C-cs" 'randomsig-replace-sig)
(define-key message-mode-map "\C-cS" 'randomsig-select-sig)

(define-key gnus-summary-save-map "-" 'gnus/randomsig-summary-read-sig)

(setq randomsig-dir "~/el/sigs/")
;(setq randomsig-files '("mail/zonix"))
(setq randomsig-files 'randomsig-search-sigfiles)
;(setq message-signature 'randomsig-signature)
(setq randomsig-delimiter "%")
(setq randomsig-delimiter-pattern "^%$")

(defun randomsig-change-dir ()
  "Interactively change the randomsig base directory."
  (interactive)
  (setq randomsig-dir
	(read-file-name "Random signature base directory: " randomsig-dir nil t nil)))

(define-key message-mode-map "\C-cd" 'randomsig-change-dir)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; adv-random-sig.el          <http://www.zonix.de/div/adv-random-sig.el>
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;(require 'adv-random-sig)
;(setq adv-signature-dir (expand-file-name "~/el/misc/sig/body/"))
;(setq adv-signature-head (expand-file-name "~/el/misc/sig/head/default"))
;(setq adv-signature-head nil)
;(setq adv-signature-greeting (expand-file-name "~/el/misc/sig/greeter/german"))
;(setq adv-signature-greeting nil)
