;; -*- emacs-lisp -*-
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; $Id: gnus_tc.el,v 1.6 2006-11-06 21:02:42 rscholz Exp $
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Trivial Cite - schner zitieren
;;
;; Die offizielle Quelle dieser Datei ist
;;   <http://www.zonix.de/projects/emacs/config>
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; tc.el                    <http://shasta.cs.uiuc.edu/~lrclause/tc.html>
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(autoload 'trivial-cite "tc" t t)

(setq message-cite-function 'trivial-cite)
;(setq tc-make-attribution 'kai-tc-simple-attribution)

(setq tc-cleanup-cited-marks-p t)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Ntzliche Funktionen
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; von Matthias Wiehl

(defvar mw/rs-tc-verb "writes")
(defvar mw/rs-tc-anon "Anonymous coward")

(defun mw/rs-tc-simple-attribution ()
  "Produce an attribution string, using configurable strings."
  (let ((email (assoc "email-addr" tc-strings-list))
        (name (assoc "real-name" tc-strings-list)))
    (if (null name)
	(concat mw/rs-tc-anon " <" (cdr email) "> " mw/rs-tc-verb ":\n\n")
      (concat (cdr name) " <" (cdr email) "> " mw/rs-tc-verb ":\n\n"))))

(setq tc-make-attribution 'mw/rs-tc-simple-attribution)



;; Mattias Wiehl in <87zo9y9omm.agb@fulmine.dhs.org>
(defun svengo-tc-attribution ()
  (let ((email (assoc "email-addr" tc-strings-list))
        (name (assoc "real-name" tc-strings-list)))
    (concat "* Quoting "
            (cdr name) " <" (cdr email) ">:\n")))

;(setq message-cite-function 'trivial-cite
;      tc-make-attribution 'svengo-tc-attribution)
